
# ================================================================================================== #
#                                                                                                    #
#                            Introductory Tutorials for Scientific Python                            #
#                  ===============================================================                   #
#                          SAMSI/NCSU Undergraduate Workshop: May 15, 2017                           #
#                                                                                                    #
#                                          Ahmed Attia                                               #
#                                North Carolina State University,                                    #
#                      Statistical and Applied Mathematical Science Institute                        #
#                                  attia@{vt.edu; samsi.info}                                        #
#                               http://people.cs.vt.edu/~attia/                                      #
#                                                                                                    #
# ================================================================================================== # 
#   Lesson 1:                                                                                        #
#             - Python's Basic Data Types.                                                           #
# ================================================================================================== # 


msg = """
 Python supports a variety of data types.
 It can also allocate memory dynamically, and does not require data type declaration, 
   e.g. such as in Fortran or C.

 We will start with:
 Strings: str
 Numberical types: int, long, float, complex
 Boolean: bool

 But there are more: Check https://en.wikibooks.org/wiki/Python_Programming/Data_Types
 """
print(msg)
raw_input("\npress Enter to continue")

msg = """
 Note that all these data types, are in fact objects, and have several properties/attributes, 
    and associated methods (functions that operate on the object instance).
 The methods, and properties associated with an object are accessed using the [.], i.e. dot operator.
""" 
print(msg)
raw_input("\npress Enter to continue")


#
# Numbers (integers, real, and complex):
# ---------------------------------------
print("\n1- Numerical data types: [read the script]")
x1 = 3
x2 = int(3)
print(x1)
print(x2)

x3 = long(3)
x4 = float(3)
print(x3)
print(x4)

y1 = 2.12
y2 = int(-12.0)
y3 = int(-12.6)
print(y1)
print(y2)
print(y3)

z1 = complex(3)
z2 = complex(3, -7.23)
print(z1)
print(z2)

raw_input("\npress Enter to continue")

#
# Strings:
# -----------------
print("\n2- String data type:")
print(" In Python, a string is defined using single, double, triple-double quotes.")
str1 = ' This is a string defined with single quote '
str2 = " This is a string defined with single quote"
str3 = " You can put a single quote (') withing pair of double quotes"
str4 = """ This is string that can span 
           multiple 
           lines
       """
print(str1)
print(str2)
print(str3)
print(str4)

raw_input("\npress Enter to continue")


#
# Boolean
# -----------------
print("\n1- Boolean data type:")
msg = """
 Boolean is True/False valued-variable or object. This is generally the result of logical expression
 or comparison such as 3>2
 We will come back to this soon
"""
logical_expr = 3 > 2
print('3 > 2: '),
print(logical_expr)

raw_input("\npress Enter to continue")



#
# None data type:
# -----------------
msg = """
    There is aother interesting data type in Python, which is Non-DataType: None
    This data type is really useful, from my experience.
"""
print(msg)

x = None
print("x=", x)
print("x is None: %s" % (x is None))
print("x is not None: %s" % (x is not None))


# ================================================================================================== # 

