
# ================================================================================================== #
#                                                                                                    #
#                            Introductory Tutorials for Scientific Python                            #
#                  ===============================================================                   #
#                          SAMSI/NCSU Undergraduate Workshop: May 15, 2017                           #
#                                                                                                    #
#                                          Ahmed Attia                                               #
#                                North Carolina State University,                                    #
#                      Statistical and Applied Mathematical Science Institute                        #
#                                  attia@{vt.edu; samsi.info}                                        #
#                               http://people.cs.vt.edu/~attia/                                      #
#                                                                                                    #
# ================================================================================================== # 
#   Lesson 2:                                                                                        #
#             - Basic Boolean operations.                                                            #
# ================================================================================================== # 

msg = """
The following logical operations are very usefule:
    >, < , ==, >=, <=, !=
    in, not in, is, is not
    not, and, or

You can also use double expressions such as a < x < b.

The priority of all these is less than arithmetics, and is ranked from highes to lowest as follows:
    1- >, < , ==, >=, <=, !=, in, not in, is, is not
    2- not
    3- and
    4- or

For full operator precedency, check:
https://docs.python.org/2/reference/expressions.html#operator-precedence
"""
print(msg)
raw_input("\npress Enter to continue")

#
# Examples:
# ------------------
print("Here are some examples on Boolean(logical) operations:\n%s" % ('-'*50))
print(" 3<5: "), 
print(3<5)
print(" 3<5 and 12<12.00000001: "), 
print(3<5 and 12<12.00000001)

raw_input("\npress Enter to continue")

print(" -1.0 < 2 < 7.41: "), 
print(-1.0 < 2 < 7.41)

expr = "3 < 12 < 12 or 3 > 2 and not -5<7 "
print(" %s: " % expr), 
print(eval(expr))  # eval is a builtin function that takes a string and evaluate it as an expression!

expr = "(1<0) is True "
print(" %s: " % expr), 
print(eval(expr))

# we define a variable x (so it's not None):
x = 3
test = x is None
print(" x is None: ", test)

# ================================================================================================== # 

