
# ================================================================================================== #
#                                                                                                    #
#                            Introductory Tutorials for Scientific Python                            #
#                  ===============================================================                   #
#                          SAMSI/NCSU Undergraduate Workshop: May 15, 2017                           #
#                                                                                                    #
#                                          Ahmed Attia                                               #
#                                North Carolina State University,                                    #
#                      Statistical and Applied Mathematical Science Institute                        #
#                                  attia@{vt.edu; samsi.info}                                        #
#                               http://people.cs.vt.edu/~attia/                                      #
#                                                                                                    #
# ================================================================================================== # 
#   Lesson 2:                                                                                        #
#             - Basic Numerical operations.                                                          #
# ================================================================================================== # 

#
# adding two integers
print("\nAdding two integers")
print("5 + 2 = "),
print(5 + 12)
raw_input("\npress Enter to continue")

# adding an integer to a float
print("\nAdding an integer to a floatintegers")
print("5 + 12.0 = "),
print(5 + 12.0)
raw_input("\npress Enter to continue")

# multiplying two numbers
print("\nMultiplying two numbers")
print("5 * 12 = %d" % (5*12) )
print("5.0 * 12 = %f" % (5.0 * 12) )
print("5.12 * 12 = %5.3f" % (5.12 * 12) )
raw_input("\npress Enter to continue")

# ??? Getting ugly? Let's try using variables; (think of a VARIABLE as a NAMED Memory Location)!
# print("\n??? Getting ugly? Let's start using variables \n")
# raw_input("\npress Enter to continue")

# integer division
print("\nInteger division")
x = 12 / 5
y = 5 / 12
print("12 / 5 = %d, and 5 / 12 = %d " % (x, y) )
raw_input("\npress Enter to continue")

# real (or mixed type) division
print("real (or mixed type) division")
oper1 = "-5.0 / 12 = "
res1 = -5.0 / 12
print(oper1, res1)  # Notice how print works in this case?!
#
oper_2 = "12 / (-5) = "
res_2 = 12 / (-5)
print(oper_2 + res_2)  # this will result in an error (raise a 'TypeError Exception) [read the script]
# print(oper_2 + str(res_2))  # This corrects the error; so comment the previous line to continue!

raw_input("\npress Enter to continue")

# quotient and remainder
print("Quotient and remainder")
oper = "12 // 5"
res = eval(oper)  # 'eval' is a function that evaluates a string as a numerical expression
output = oper + " = " + str(res)
print(output)

print("12 %% 5 = %d" % (12%5) )
print("12 // 5.0 = %f" % (12//5.0) )
print("12 %% 5.0 = %f" % (12 % 5.0) )

raw_input("\npress Enter to continue")

# number exponentiation
print("Number exponentiation")
print("12 ** 3 = %f" % (12 ** 3))
print("12 ** 3.0 = %f" % (12 ** 3.0) )
print("12 ** 0.33 = %f" % (12 ** 0.33) )
print("12 ** (1/3) = %f" % (12 ** (1/3)) )   # note which operation is carried out first (priority)?

# complex numbers
print("Complex numbers")
x = complex(3, 12)
y = x * 2
z = x + y.conjugate()  # add x to the complex conjugate of y
print("x = %s" % x)  # %s forces the interpretter to get string repr of x. Works with simple objects
print("y = %s" % y)
print("z = %s" % z)

msg = """
Remember that: 
    Priorities from highest: 
      1- round brackets(), 
      2- unitary, 
      3- power, 
      4  product, division, quotient, remainder
      5- addition, subtraction
"""
print(msg)

# ================================================================================================== #

