
# ================================================================================================== #
#                                                                                                    #
#                            Introductory Tutorials for Scientific Python                            #
#                  ===============================================================                   #
#                          SAMSI/NCSU Undergraduate Workshop: May 15, 2017                           #
#                                                                                                    #
#                                          Ahmed Attia                                               #
#                                North Carolina State University,                                    #
#                      Statistical and Applied Mathematical Science Institute                        #
#                                  attia@{vt.edu; samsi.info}                                        #
#                               http://people.cs.vt.edu/~attia/                                      #
#                                                                                                    #
# ================================================================================================== # 
#   Lesson 3:                                                                                        #
#             - Data Structures, and iterables: Dictionaries.                                        #
# ================================================================================================== # 

#
# 3- Dictionaries:
# --------------------
msg = """
Dictionaries are amongest the key features of Python.

A Python dictionary is a set of unordered pairs of (key, value).  # () here doesn't implicate a tuple!

A dictionary can be created using curly brackets as follows:

{key0:value <, key1:value, ...>}

The values of a dictionary can be of ANY type (number, string, list, tuple, dictionary, etc.), 
    but the keys must be of an immutable data type e.g. strings, numbers, tuples, or a combination.
Keys MUST be unique within a dictionary while values can differ. 

Key elements are accessed using a key with squared brackets

"""
print(msg)
raw_input("\npress Enter to continue")

#
msg = """
# -------------------------------------------------------------------------------------------------- #
#                                           Exercise 0:                                              #
#     Create a dictionary named 'my_week' with keys and values as follows:                           #
#                                                                                                    #
#           key         | Value                                                                      #
#           ____________________________________________________                                     #
#           'Monday'    | 'My week starts tomorrow!'                                                 #
#           'Tuesday'   | 'No Events'                                                                #
#           'Wednesday' | 'No Events'                                                                #
#           'Thursday'  | ['go to SAMSI', 'email attia@vt.edu']                                      #
#           'Friday'    | {1:'break', 2:'break', 3:'break'}                                          #
#           ____________________________________________________                                     #
#                                                                                                    #
#     Change the last entry of Friday schedule to 'Skype meeting', then print Friday's schedule.     #
#                                                                                                    #
# -------------------------------------------------------------------------------------------------- #
"""
print(msg)
raw_input("\npress Enter to continue")
#
# Solution
#-------------------
my_week = {'Monday': 'My week starts tomorrow!',
           'Tuesday': 'No Events',
           'Wednesday': 'No Events',
           'Thursday': ['go to SAMSI', 'email attia@vt.edu'],
           'Friday': {1:'break', 2:'break', 3:'break'}
           }
print("My Friday schedule is:")
friday_schedule = my_week['Friday']  # note that this assigns a pointer not a value!
friday_schedule[3] = 'Skype meeting'
print(friday_schedule)

raw_input("\npress Enter to continue")

msg = """
Dictionaries are mutable; you can change it's contents. 
You can access, and updated the value corresponding a key by slicing as in the previous example.


The following methods associated with a dictionary object are frequently used:
        _____________________________________________________________________________________________
         Method      | Action                                                                      
        _____________________________________________________________________________________________
         clear()     | remove all items from a dictionary
         keys()      | return a list of keys in a dictionary
         has_key()   | check if a key is in the dictionary; return True, otherwise return False
         pop()       | remove specified key and return the corresponding value
         update()    | update the dictionary given elements of another dictionary (add or overwrite)
        _____________________________________________________________________________________________
"""
print(msg)
raw_input("\npress Enter to continue")


msg = """
# ================================================================================================== #
#                                           Exercise 1:                                              #
#     Let us try modify the dictionary 'my_week' (print the dictionary after each commend):          #
#       1- Clear Friday schedule.                                                                    #
#       2- Check if there an entry for 'thursday', and 'Saturday'.                                   #
#       3- update 'Tuesday' schedule to contain two meetings                                         #
#       4- List all days/keys in the dictionary, and the number of days in the dictionary.           #
#     Let us try modify the dictionary 'my_week':                                                    #
# ================================================================================================== #
"""
print(msg)
raw_input("\npress Enter to continue")
#
# Solution
#-------------------


msg = """
Remark:
--------
    Python provides the operator 'in' that checks if an instance occures in an object.
    You can use it to check if a key exists in a dictionary.
"""
print(msg)

expr = " 'Friday' in my_week "
print("The result of the expression:\n\n \r%s\n\n is:%s " %(expr, eval(expr))) 
raw_input("\npress Enter to continue")


remark = """
Remark:
--------
    Another data structure is 'set' that is unordered sequence of elements defined by curly brackets, 
    and supports set operations such as Union, Intersection, etc.
"""
print(remark)


# ================================================================================================== #


