
# ================================================================================================== #
#                                                                                                    #
#                            Introductory Tutorials for Scientific Python                            #
#                  ===============================================================                   #
#                          SAMSI/NCSU Undergraduate Workshop: May 15, 2017                           #
#                                                                                                    #
#                                          Ahmed Attia                                               #
#                                North Carolina State University,                                    #
#                      Statistical and Applied Mathematical Science Institute                        #
#                                  attia@{vt.edu; samsi.info}                                        #
#                               http://people.cs.vt.edu/~attia/                                      #
#                                                                                                    #
# ================================================================================================== # 
#   Lesson 3:                                                                                        #
#             - Data Structures, and iterables: Tuples.                                              #
# ================================================================================================== # 


#
# 2- Tuples
# -------------
msg = """
A 'tuple' is an ordered, UNmutable object, that contains a set of (non)homogenous elements.
Think of it, as a constant list!

A tuple is created using round brackets, with entries separated by commas:
e.g.
tuple_0 = (1, 2, 12, 12.44, -10000)
tuple_1 = (5, 'SAMSI', None, "", 30%7)
tuple_2 = (3>-1+5, [23, 12, -50], tuple_1)

The tuple object is an iterable, indexed starting at 0, as in lists. 
Slicing is similar to slicing in lists.

You can add two tuples, or multiply a tuple by an integer to replicate it (creating a new object),
but UNLIKE lists, you CANNOT change the contents of a tuple object.
"""
print(msg)
raw_input("\npress Enter to continue")

tuple_0 = (1, 2, 12, 12.44, -10000)
tuple_1 = (5, 'SAMSI', None, "", 30%7)
tuple_2 = (3>-1+5, [23, 12, -50], tuple_1)

print("Example:\n \rThe result of executing the command \n\n \rprint((tuple_0+tuple_1)*2) \n\nis: ")
print((tuple_0+tuple_1)*2)

print("Accessing tuple_0[1]: "),
print(tuple_0[1])
# tuple_2[0] = 12  # This will raise a TypeError exception
raw_input("\npress Enter to continue")

msg = """
# -------------------------------------------------------------------------------------------------- #
#                                           Exercise 0:                                              #
#                           how many times does 12 occur in tuple_0 ?                                #
#                           how many times does 17 occur in tuple_0 ?                                #
#                           Hint: try tuple_0.count(12)                                              #
# -------------------------------------------------------------------------------------------------- #
"""
print(msg)

print("Number of occurences of 12 in tuple_0 is: "),
print(tuple_0.count(12))
print("Number of occurences of 17 in typle_0 is: %d" % tuple_0.count(17) )

# ================================================================================================== # 

