
# ================================================================================================== #
#                                                                                                    #
#                            Introductory Tutorials for Scientific Python                            #
#                  ===============================================================                   #
#                          SAMSI/NCSU Undergraduate Workshop: May 15, 2017                           #
#                                                                                                    #
#                                          Ahmed Attia                                               #
#                                North Carolina State University,                                    #
#                      Statistical and Applied Mathematical Science Institute                        #
#                                  attia@{vt.edu; samsi.info}                                        #
#                               http://people.cs.vt.edu/~attia/                                      #
#                                                                                                    #
# ================================================================================================== # 
#   Lesson 5:                                                                                        #
#             - Functions                                                                            #
# ================================================================================================== # 

msg = """
External built-in functions in python are inside a module named "__builtin__"
We can check on Ipython, and discuss: 
    , , , int, float, str, None, max, min, abs, etc.
    
    _____________________________________________________________________________________________
     Function      | Action                                                                      
    _____________________________________________________________________________________________
     type()        | 
     eval()        | 
     isinstance()  | 
     int()         | 
     float()       | 
     str()         | 
     max()         | 
     min()         |
     abs()         |
     ...
    _____________________________________________________________________________________________
"""
print(msg)
raw_input("\npress Enter to continue")


msg = """
To define a function, use 'def', where the body of the function MUST be Indented:

def [function name]([function arguments]):
    <Optional, but recommended docstring within tripple double quotes>
    [Body of the function]
    <return object(s)> 
    
If we have time, we will learn this in class interactively!

Notes:
    1- Primitive objects (str, int, float) are passed by value, while mutable objects 
       (such as iterables) are passed by reference. Be carefule here!
    2- Arguments can be unnamed (mandatory), or named with default values(optional)
    3- Named arguments can be passed in any order.
    4- Exercise; check online for *args, and **kwargs use in Python functions
    5- You can define a function withing a function; this can potentially create spaghetti code!

Remark:
------------
you can define a simple inline function using 'lambda':
square_fun = lambda x: x ** 2
creates a function named 'square function named 'square_fun' that returns the square of it's input

"""
print(msg)
raw_input("\npress Enter to continue")


# Example 0:
exercise0 = """
# -------------------------------------------------------------------------------------------------- #
#                                           Exercise 0:                                              #
#                                                                                                    #
# 1- define a function named square that prints the square of a number, then try using it            #
# 2- Add an ASSERTION to the inputs of the function,                                                 #
# 3- Does this function return anything? If yes, what is it's type?                                  #
# 4- Now, add a return statement, that returns the passed number and it's square, then use it.       #
#                                                                                                    #
# -------------------------------------------------------------------------------------------------- #
"""
print(exercise0)
raw_input("\npress Enter to continue")
#
# Solution
# -------------

# Example 1:
exercise1 = """
# -------------------------------------------------------------------------------------------------- #
#                                           Exercise 1:                                              #
#                                                                                                    #
# 1- define a function named 'prod_div' that accepts two numbers,                                    #
#    and a basic numeric operation, to apply on them, then optionally print the result,              #
#    and finally, return the result.                                                                 #
#                                                                                                    #
# -------------------------------------------------------------------------------------------------- #
"""
print(exercise1)
raw_input("\npress Enter to continue")
#
# Solution
# -------------


exercise2 = """
# -------------------------------------------------------------------------------------------------- #
#                                           Exercise 2:                                              #
#                                                                                                    #
# How do you think the scope of the variables works?                                                 #
#                                                                                                    #
#                                           Exercise 2:                                              #
# Exercise [in class] to create a module, with some variables, and functions to explain              #
# scope, and shadowing.                                                                              #
# -------------------------------------------------------------------------------------------------- #
"""
print(exercise2)
#
# Solution
# -------------


exercise2 = """
# -------------------------------------------------------------------------------------------------- #
#                                           Exercise 3:                                              #
#                                                                                                    #
# using 'lambda', create a function that returns the cubic root of a number                          #
# -------------------------------------------------------------------------------------------------- #
"""
print(exercise3)
#
# Solution
# -------------



# ================================================================================================== #

