
# ================================================================================================== #
#                                                                                                    #
#                            Introductory Tutorials for Scientific Python                            #
#                  ===============================================================                   #
#                          SAMSI/NCSU Undergraduate Workshop: May 15, 2017                           #
#                                                                                                    #
#                                          Ahmed Attia                                               #
#                                North Carolina State University,                                    #
#                      Statistical and Applied Mathematical Science Institute                        #
#                                  attia@{vt.edu; samsi.info}                                        #
#                               http://people.cs.vt.edu/~attia/                                      #
#                                                                                                    #
# ================================================================================================== # 
#   Lesson 6:                                                                                        #
#             - modules                                                                              #
# ================================================================================================== # 

msg = """
The basic (built-in) functions, and variables are available to be used directly, 
however if you want to use additional objects (variables, functions, etc.), you need to 
IMPORT them first.

The components (variables, functions, classes, etc.) of a Python module, or a (.py) file can be 
imported into the current working space, using the 'import' statement.

import [module name] : imports the module with it's name
import [module 1], [module 2]
import [module name] as alias: imports the module with an alias name 
from [module name] import [variable, function, class, module, etc.] as alias

Notes:
--------
 1- If a module is imported, it's contents can be accessed using the [.] operator
 2- The following statement imports everything(ish) from a module
    from [module name] import *. This is 'BAD ' though!
    
"""
print(msg)
raw_input("\npress Enter to continue")

# Example 0:
exercise0 = """
# -------------------------------------------------------------------------------------------------- #
#                                           Exercise 0:                                              #
#                                                                                                    #
# 1- import sys module, print it's documentation, and check the functions available in it,           #
# 2- Import sqrt from math module,                                                                   #
# 3- Import the functions randint and randrange from the module random, and check their use.         #
# -------------------------------------------------------------------------------------------------- #
"""
print(exercise0)
raw_input("\npress Enter to continue")
# Solution:
# -----------
import sys
print(sys.__doc__)  # __doc__ is a descriptor used to (automatically) store documentation (docstring). 

from math import sqrt
from random import randint, randrange
print(randint.__doc__)
print(randrange.__doc__)

raw_input("\npress Enter to continue")


exercise1 = """
# -------------------------------------------------------------------------------------------------- #
#                                           Exercise 1:                                              #
#                                                                                                    #
#                                  <Use IPython for this exercise.>                                  #
#                                                                                                    #
# 1- Create a module, with some variables in it, start some of these variables with an underscore.   #
# 2- Import this module into the current work space, and check the objects asociated to it.          #
# 3- Delete the module; Hint use 'delete [objet-name]'                                               #
# 4- Import everything from that module your created using 'import *'. What do you notice?           #
# -------------------------------------------------------------------------------------------------- #
"""
print(exercise1)
raw_input("\npress Enter to continue")
# Solution (in class):
# ----------------------


# ================================================================================================== # 

